<?php

class WP_xmlrpc_api {
	
	var $xmlrpcserwer;
	var $uzytkownik;
	var $haslo;
	var $uzywajcurl = false;
	
	function _construct($xmlrpcserwer, $uzytkownik, $haslo) {
		
		$this->xmlrpcserwer = $xmlrpcserwer;
		$this->uzytkownik = $uzytkownik;
		$this->haslo = $haslo; 
	
	}
	
	
	
	function nowyPost($tytul, $tresc, $kategorie = array(1), $opublikowany = 1) {
		
		$xml = $this->nowyPostXML($tytul, $tresc, $kategorie, $opublikowany);
		$response = ($this->uzywajcurl) ? $this->curlRequest($xml) : $this->standardRequest($xml);
		unset($response);
		
	}
	
	
	function nowyPostXML($tytul, $tresc, $kategorie, $opublikowany) {
	
	$xml = '<?xml version="1.0" encoding="utf-8"?>'.
'<methodCall>'.
'<methodName>wp.newPost</methodName>'.
'<params>'.

'<param>'.
'<value>'.
'<string/>'.
'</value>'.
'</param>'.
 
'<param>'.
'<value>'.
'<string/>'.
'</value>'.
'</param>'.
 
'<param>'.
'<value>'.
'<string>'.$this->uzytkownik.'</string>'.
'</value>'.
'</param>'.
 
'<param>'.
'<value>'.
'<string>'.$this->haslo.'</string>'.
'</value>'.
'</param>'.
 
'<param>'.
'<value>'.
'<string>&lt;title&gt;'.htmlspecialchars($tytul).'&lt;/title&gt; &lt;category&gt;'.implode(",", $kategorie).'&lt;/category&gt;'.htmlspecialchars($tresc).'</string>'.
'</value>'.
'</param>'.
 
'<param>'.
'<value>'.
'<int>'.$opublikowany.'</int>'.
'</value>'.
'</param>'.

'</params>'.
'</methodCall>';
	
		return $xml;
	
	}
	
	
	function standardRequest($xml) {
		
		$context = stream_context_create(
            array(
                'http' => array(
                    'method' => "POST",
                    'header' => "Content-Type: text/xml",
                    'content' => $xml
                )
            )
        );
		
		$response = file_get_contents($this->xmlrpcserwer, false, $context);
		
		return $response;
	
	}
	
	function curlRequest($xml) {
		
		$ch = curl_init();
		curl_setopt( $ch, CURLOPT_URL, $this->xmlrpcserwer); 
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 ); 
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $xml );
		$response = curl_exec( $ch );
		curl_close($ch); 
		
		return $response;
	
	}
	
	
}

?>
